Index: code/trunk/src/external/tolua/lua/package.lua
===================================================================
--- code/trunk/src/external/tolua/lua/package.lua	(revision 11056)
+++ code/trunk/src/external/tolua/lua/package.lua	(revision 11071)
@@ -82,4 +82,5 @@
     self.code = gsub(self.code,"%s*@%s*","@") -- eliminate spaces beside @
     self.code = gsub(self.code,"%s?inline(%s)","%1") -- eliminate 'inline' keyword
+    self.code = gsub(self.code,"%)%s?override;",");") -- eliminate 'override' keyword... at least most of the times
     --self.code = gsub(self.code,"%s?extern(%s)","%1") -- eliminate 'extern' keyword
     --self.code = gsub(self.code,"%s?virtual(%s)","%1") -- eliminate 'virtual' keyword
Index: code/trunk/src/libraries/core/ApplicationPaths.cc
===================================================================
--- code/trunk/src/libraries/core/ApplicationPaths.cc	(revision 11056)
+++ code/trunk/src/libraries/core/ApplicationPaths.cc	(revision 11071)
@@ -68,5 +68,5 @@
 
     //! Static pointer to the singleton
-    ApplicationPaths* ApplicationPaths::singletonPtr_s  = 0;
+    ApplicationPaths* ApplicationPaths::singletonPtr_s  = nullptr;
 
     ApplicationPaths::ApplicationPaths()
@@ -84,5 +84,5 @@
         // get executable module
         TCHAR buffer[1024];
-        if (GetModuleFileName(NULL, buffer, 1024) == 0)
+        if (GetModuleFileName(nullptr, buffer, 1024) == 0)
             ThrowException(General, "Could not retrieve executable path.");
 
Index: code/trunk/src/libraries/core/ApplicationPaths.h
===================================================================
--- code/trunk/src/libraries/core/ApplicationPaths.h	(revision 11056)
+++ code/trunk/src/libraries/core/ApplicationPaths.h	(revision 11071)
@@ -104,5 +104,7 @@
 
         private:
-            ApplicationPaths(const ApplicationPaths&); //!< Don't use (undefined symbol)
+            // non-copyable:
+            ApplicationPaths(const ApplicationPaths&) = delete;
+            ApplicationPaths& operator=(const ApplicationPaths&) = delete;
 
             std::vector<std::string> getModuleOrPluginPaths(boost::filesystem::path& directory, const std::string& extension);
Index: code/trunk/src/libraries/core/BaseObject.cc
===================================================================
--- code/trunk/src/libraries/core/BaseObject.cc	(revision 11056)
+++ code/trunk/src/libraries/core/BaseObject.cc	(revision 11071)
@@ -65,7 +65,7 @@
         this->bRegisteredEventStates_ = false;
 
-        this->lastLoadedXMLElement_ = 0;
-
-        this->mainStateFunctor_ = 0;
+        this->lastLoadedXMLElement_ = nullptr;
+
+        this->mainStateFunctor_ = nullptr;
 
         if (context)
@@ -86,5 +86,5 @@
         else
         {
-            this->file_ = 0;
+            this->file_ = nullptr;
             this->sceneID_ = OBJECTID_UNKNOWN;
         }
@@ -132,5 +132,5 @@
         XMLPortObject(BaseObject, BaseObject, "eventlisteners", addEventListener, getEventListener, xmlelement, mode);
 
-        Element* events = 0;
+        Element* events = nullptr;
         if (mode == XMLPort::LoadObject || mode == XMLPort::ExpandObject)
             events = xmlelement.FirstChildElement("events", false);
@@ -163,6 +163,6 @@
         this->setName(name);
 
-        for (ObjectList<XMLNameListener>::iterator it = ObjectList<XMLNameListener>::begin(); it != ObjectList<XMLNameListener>::end(); ++it)
-            it->loadedNewXMLName(this);
+        for (XMLNameListener* listener : ObjectList<XMLNameListener>())
+            listener->loadedNewXMLName(this);
     }
 
@@ -205,5 +205,5 @@
             Template* link;
             assert(!(link = Template::getTemplate(temp->getLink())) || !link->isLink());
-            link = NULL;
+            link = nullptr;
         }
         else
@@ -234,11 +234,11 @@
     {
         unsigned int i = 0;
-        for (std::set<Template*>::const_iterator it = this->templates_.begin(); it != this->templates_.end(); ++it)
+        for (Template* temp : this->templates_)
         {
             if (i == index)
-                return (*it);
+                return temp;
             i++;
         }
-        return 0;
+        return nullptr;
     }
 
@@ -269,14 +269,14 @@
     {
         unsigned int i = 0;
-        for (std::map<BaseObject*, std::string>::const_iterator it = this->eventSources_.begin(); it != this->eventSources_.end(); ++it)
-        {
-            if (it->second != state)
+        for (const auto& mapEntry : this->eventSources_)
+        {
+            if (mapEntry.second != state)
                 continue;
 
             if (i == index)
-                return it->first;
+                return mapEntry.first;
             ++i;
         }
-        return 0;
+        return nullptr;
     }
 
@@ -296,11 +296,11 @@
     {
         unsigned int i = 0;
-        for (std::set<BaseObject*>::const_iterator it = this->eventListenersXML_.begin(); it != this->eventListenersXML_.end(); ++it)
+        for (BaseObject* listener : this->eventListenersXML_)
         {
             if (i == index)
-                return *it;
+                return listener;
             ++i;
         }
-        return 0;
+        return nullptr;
     }
 
@@ -331,5 +331,5 @@
             return (it->second);
         else
-            return 0;
+            return nullptr;
     }
 
@@ -358,8 +358,8 @@
         Event event(activate, originator, name);
 
-        for (std::set<BaseObject*>::iterator it = this->eventListeners_.begin(); it != this->eventListeners_.end(); ++it)
-        {
-            event.statename_ = (*it)->eventSources_[this];
-            (*it)->processEvent(event);
+        for (BaseObject* listener : this->eventListeners_)
+        {
+            event.statename_ = listener->eventSources_[this];
+            listener->processEvent(event);
         }
     }
@@ -370,6 +370,6 @@
     void BaseObject::fireEvent(Event& event)
     {
-        for (std::set<BaseObject*>::iterator it = this->eventListeners_.begin(); it != this->eventListeners_.end(); ++it)
-            (*it)->processEvent(event);
+        for (BaseObject* listener : this->eventListeners_)
+            listener->processEvent(event);
     }
 
@@ -423,5 +423,5 @@
     void BaseObject::changedMainStateName()
     {
-        this->mainStateFunctor_ = 0;
+        this->mainStateFunctor_ = nullptr;
 
         if (!this->mainStateName_.empty())
@@ -474,8 +474,6 @@
 
             // iterate through all states and get the event sources
-            for (std::list<std::string>::iterator it = eventnames.begin(); it != eventnames.end(); ++it)
-            {
-                const std::string& statename = (*it);
-
+            for (const std::string& statename : eventnames)
+            {
                 // if the event state is already known, continue with the next state
                 orxonox::EventState* eventstate = object->getEventState(statename);
Index: code/trunk/src/libraries/core/BaseObject.h
===================================================================
--- code/trunk/src/libraries/core/BaseObject.h	(revision 11056)
+++ code/trunk/src/libraries/core/BaseObject.h	(revision 11071)
@@ -163,5 +163,5 @@
             inline void setScene(const StrongOrWeakPtr<Scene>& scene, uint32_t sceneID) { this->scene_ = scene; this->sceneID_=sceneID; }
             inline Scene* getScene() const { return this->scene_.get(); }
-            inline virtual uint32_t getSceneID() const { return this->sceneID_; }
+            virtual inline uint32_t getSceneID() const { return this->sceneID_; }
 
             inline void setGametype(const StrongOrWeakPtr<Gametype>& gametype) { this->gametype_ = gametype; }
@@ -218,5 +218,5 @@
             bool                       bInitialized_;          //!< True if the object was initialized (passed the object registration)
             const XMLFile*             file_;                  //!< The XMLFile that loaded this object
-            Element*                   lastLoadedXMLElement_;  //!< Non 0 if the TinyXML attributes have already been copied to our own lowercase map
+            Element*                   lastLoadedXMLElement_;  //!< Non nullptr if the TinyXML attributes have already been copied to our own lowercase map
             std::map<std::string, std::string> xmlAttributes_; //!< Lowercase XML attributes
             std::string                loaderIndentation_;     //!< Indentation of the debug output in the Loader
@@ -265,5 +265,5 @@
             return this->weakPtr_;
         else
-            return NULL;
+            return nullptr;
     }
 
Index: code/trunk/src/libraries/core/ClassTreeMask.cc
===================================================================
--- code/trunk/src/libraries/core/ClassTreeMask.cc	(revision 11056)
+++ code/trunk/src/libraries/core/ClassTreeMask.cc	(revision 11071)
@@ -207,5 +207,5 @@
             return ((*this->nodes_.top().first) == compare);
         else
-            return (compare == 0);
+            return (compare == nullptr);
     }
 
@@ -218,5 +218,5 @@
             return ((*this->nodes_.top().first) != compare);
         else
-            return (compare != 0);
+            return (compare != nullptr);
     }
 
@@ -293,8 +293,8 @@
         {
             // No it's not: Search for classes inheriting from the given class and add the rules for them
-            for (std::set<const Identifier*>::const_iterator it = subclass->getDirectChildren().begin(); it != subclass->getDirectChildren().end(); ++it)
-                if ((*it)->isA(this->root_->getClass()))
-                    if (overwrite || (!this->nodeExists(*it))) // If we don't want to overwrite, only add nodes that don't already exist
-                        this->add(this->root_, *it, bInclude, overwrite);
+            for (const Identifier* directChild : subclass->getDirectChildren())
+                if (directChild->isA(this->root_->getClass()))
+                    if (overwrite || (!this->nodeExists(directChild))) // If we don't want to overwrite, only add nodes that don't already exist
+                        this->add(this->root_, directChild, bInclude, overwrite);
         }
 
@@ -325,10 +325,10 @@
         {
             // Search for an already existing node, containing the subclass we want to add
-            for (std::list<ClassTreeMaskNode*>::iterator it = node->subnodes_.begin(); it != node->subnodes_.end(); ++it)
+            for (ClassTreeMaskNode* subnode : node->subnodes_)
             {
-                if (subclass->isA((*it)->getClass()))
+                if (subclass->isA(subnode->getClass()))
                 {
                     // We've found an existing node -> delegate the work with a recursive function-call and return
-                    this->add(*it, subclass, bInclude, overwrite);
+                    this->add(subnode, subclass, bInclude, overwrite);
                     return;
                 }
@@ -392,6 +392,6 @@
         if (!subclass)
             return;
-        for (std::set<const Identifier*>::const_iterator it = subclass->getDirectChildren().begin(); it != subclass->getDirectChildren().end(); ++it)
-            this->add(*it, this->isIncluded(*it), false, false);
+        for (const Identifier* directChild : subclass->getDirectChildren())
+            this->add(directChild, this->isIncluded(directChild), false, false);
 
         this->add(subclass, bInclude, false, clean);
@@ -435,7 +435,7 @@
 
             // Go through the list of subnodes and look for a node containing the searched subclass and delegate the request by a recursive function-call.
-            for (std::list<ClassTreeMaskNode*>::iterator it = node->subnodes_.begin(); it != node->subnodes_.end(); ++it)
-                if (subclass->isA((*it)->getClass()))
-                    return isIncluded(*it, subclass);
+            for (ClassTreeMaskNode* subnode : node->subnodes_)
+                if (subclass->isA(subnode->getClass()))
+                    return isIncluded(subnode, subclass);
 
             // There is no subnode containing our class -> the rule of the current node takes in effect
@@ -851,5 +851,5 @@
             this->objectIterator_ = Context::getRootContext()->getObjectList(this->subclassIterator_->first)->begin();
         else
-            this->objectIterator_ = ObjectList<BaseObject>::end();
+            this->objectIterator_ = ObjectList<BaseObject>().end();
 
         // Check if the iterator points on a valid object. If not, go to the next object by calling ++
@@ -915,8 +915,8 @@
 
             // Iterate through all subnodes
-            for (std::list<ClassTreeMaskNode*>::iterator it1 = node->subnodes_.begin(); it1 != node->subnodes_.end(); ++it1)
+            for (ClassTreeMaskNode* subnode : node->subnodes_)
             {
                 // Recursive call to this function with the subnode
-                this->create(*it1);
+                this->create(subnode);
 
                 // Only execute the following code if the current node is included, meaning some of the subnodes might be included too
@@ -926,22 +926,22 @@
 
                     // Iterate through all direct children
-                    for (std::set<const Identifier*>::iterator it2 = directChildren.begin(); it2 != directChildren.end(); ++it2)
+                    for (std::set<const Identifier*>::iterator it = directChildren.begin(); it != directChildren.end(); ++it)
                     {
                         // Check if the subnode (it1) is a child of the directChild (it2)
-                        if ((*it1)->getClass()->isA(*it2))
+                        if (subnode->getClass()->isA(*it))
                         {
                             // Yes it is - remove the directChild (it2) from the list, because it will already be handled by a recursive call to the create() function
-                            directChildren.erase(it2);
+                            directChildren.erase(it);
 
                             // Check if the removed directChild was exactly the subnode
-                            if (!(*it1)->getClass()->isExactlyA(*it2))
+                            if (!subnode->getClass()->isExactlyA(*it))
                             {
                                 // No, it wasn't exactly the subnode - therefore there are some classes between
 
                                 // Add the previously removed directChild (it2) to the subclass-list
-                                this->subclasses_.insert(this->subclasses_.end(), std::pair<const Identifier*, bool>(*it2, true));
+                                this->subclasses_.insert(this->subclasses_.end(), std::pair<const Identifier*, bool>(*it, true));
 
                                 // Insert all directChildren of the directChild
-                                directChildren.insert((*it2)->getDirectChildren().begin(), (*it2)->getDirectChildren().end());
+                                directChildren.insert((*it)->getDirectChildren().begin(), (*it)->getDirectChildren().end());
 
                                 // Restart the scan with the expanded set of directChildren
@@ -957,6 +957,6 @@
             // The bool is "false", meaning they have no subnodes and therefore need no further checks
             if (node->isIncluded())
-                for (std::set<const Identifier*>::iterator it = directChildren.begin(); it != directChildren.end(); ++it)
-                    this->subclasses_.insert(this->subclasses_.end(), std::pair<const Identifier*, bool>(*it, false));
+                for (const Identifier* directChild : directChildren)
+                    this->subclasses_.insert(this->subclasses_.end(), std::pair<const Identifier*, bool>(directChild, false));
         }
     }
Index: code/trunk/src/libraries/core/ClassTreeMask.h
===================================================================
--- code/trunk/src/libraries/core/ClassTreeMask.h	(revision 11056)
+++ code/trunk/src/libraries/core/ClassTreeMask.h	(revision 11071)
@@ -152,10 +152,10 @@
             ClassTreeMaskNode* operator*() const;
             ClassTreeMaskNode* operator->() const;
-            operator bool() const;
+            explicit operator bool() const;
             bool operator==(ClassTreeMaskNode* compare) const;
             bool operator!=(ClassTreeMaskNode* compare) const;
 
         private:
-            std::stack<std::pair<std::list<ClassTreeMaskNode*>::iterator, std::list<ClassTreeMaskNode*>::iterator> > nodes_;    ///< A stack to store list-iterators
+            std::stack<std::pair<std::list<ClassTreeMaskNode*>::iterator, std::list<ClassTreeMaskNode*>::iterator>> nodes_;    ///< A stack to store list-iterators
             std::list<ClassTreeMaskNode*> rootlist_;                                                                            ///< A list for internal use (it only stores the root-node)
     };
@@ -211,5 +211,5 @@
             inline const ClassTreeMask& begin() const { return (*this); }
             /// End of the ClassTreeMaskObjectIterator.
-            inline BaseObject*          end()   const { return 0; }
+            inline BaseObject*          end()   const { return nullptr; }
 
             ClassTreeMask& operator=(const ClassTreeMask& other);
@@ -276,5 +276,5 @@
         public:
             /// Default-constructor: Does nothing.
-            inline ClassTreeMaskObjectIterator() {}
+            inline ClassTreeMaskObjectIterator() = default;
             /// Copy-Constructor: Initializes the iterator from another ClassTreeMask.
             inline ClassTreeMaskObjectIterator(const ClassTreeMask& mask) { (*this) = mask; }
@@ -285,9 +285,9 @@
 
             /// Returns true if the ClassTreeMaskObjectIterator points at the given object.
-            inline bool operator==(BaseObject* pointer) const { return (this->objectIterator_ && (*this->objectIterator_) == pointer) || (!this->objectIterator_ && pointer == 0); }
+            inline bool operator==(BaseObject* pointer) const { return (this->objectIterator_ && (*this->objectIterator_) == pointer) || (!this->objectIterator_ && pointer == nullptr); }
             /// Returns true if the ClassTreeMaskObjectIterator doesn't point at the given object.
-            inline bool operator!=(BaseObject* pointer) const { return (this->objectIterator_ && (*this->objectIterator_) != pointer) || (!this->objectIterator_ && pointer != 0); }
+            inline bool operator!=(BaseObject* pointer) const { return (this->objectIterator_ && (*this->objectIterator_) != pointer) || (!this->objectIterator_ && pointer != nullptr); }
             /// Returns true if the ClassTreeMaskObjectIterator hasn't already reached the end.
-            inline operator bool() const { return (this->objectIterator_); }
+            inline explicit operator bool() const { return this->objectIterator_.operator bool(); }
             /// Returns the object the ClassTreeMaskObjectIterator currently points at.
             inline BaseObject* operator*() const { return (*this->objectIterator_); }
@@ -298,7 +298,7 @@
             void create(ClassTreeMaskNode* node);
 
-            std::list<std::pair<const Identifier*, bool> >           subclasses_;       ///< A list of all Identifiers through which objects the iterator should iterate
-            std::list<std::pair<const Identifier*, bool> >::iterator subclassIterator_; ///< The current class of the iterator
-            Iterator<BaseObject>                                     objectIterator_;   ///< The current object of the iterator
+            std::list<std::pair<const Identifier*, bool>>           subclasses_;       ///< A list of all Identifiers through which objects the iterator should iterate
+            std::list<std::pair<const Identifier*, bool>>::iterator subclassIterator_; ///< The current class of the iterator
+            Iterator<BaseObject>                                    objectIterator_;   ///< The current object of the iterator
     };
 }
Index: code/trunk/src/libraries/core/ConfigurablePaths.cc
===================================================================
--- code/trunk/src/libraries/core/ConfigurablePaths.cc	(revision 11056)
+++ code/trunk/src/libraries/core/ConfigurablePaths.cc	(revision 11071)
@@ -54,4 +54,5 @@
 #include "util/Exception.h"
 #include "commandline/CommandLineIncludes.h"
+#include "core/ApplicationPaths.h"
 
 // Differentiate Boost Filesystem v2 and v3
@@ -67,5 +68,5 @@
 
     //! Static pointer to the singleton
-    ConfigurablePaths* ConfigurablePaths::singletonPtr_s  = 0;
+    ConfigurablePaths* ConfigurablePaths::singletonPtr_s  = nullptr;
 
     SetCommandLineArgument(externalDataPath, "").information("Path to the external data files");
@@ -122,5 +123,5 @@
             char* userDataPathPtr(getenv("APPDATA"));
 #endif
-            if (userDataPathPtr == NULL)
+            if (userDataPathPtr == nullptr)
                 ThrowException(General, "Could not retrieve user data path.");
             bf::path userDataPath(userDataPathPtr);
@@ -143,9 +144,9 @@
 
         // Create directories to avoid problems when opening files in non existent folders.
-        std::vector<std::pair<bf::path, std::string> > directories;
-        directories.push_back(std::make_pair(bf::path(configPath_), std::string("config")));
-        directories.push_back(std::make_pair(bf::path(logPath_), std::string("log")));
+        std::vector<std::pair<bf::path, std::string>> directories;
+        directories.emplace_back(bf::path(configPath_), std::string("config"));
+        directories.emplace_back(bf::path(logPath_), std::string("log"));
 
-        for (std::vector<std::pair<bf::path, std::string> >::iterator it = directories.begin();
+        for (std::vector<std::pair<bf::path, std::string>>::iterator it = directories.begin();
             it != directories.end(); ++it)
         {
Index: code/trunk/src/libraries/core/ConfigurablePaths.h
===================================================================
--- code/trunk/src/libraries/core/ConfigurablePaths.h	(revision 11056)
+++ code/trunk/src/libraries/core/ConfigurablePaths.h	(revision 11071)
@@ -93,5 +93,7 @@
 
         private:
-            ConfigurablePaths(const ConfigurablePaths&); //!< Don't use (undefined symbol)
+            // non-copyable:
+            ConfigurablePaths(const ConfigurablePaths&) = delete;
+            ConfigurablePaths& operator=(const ConfigurablePaths&) = delete;
 
             boost::filesystem::path& dataPath_;              //!< Path to the data files folder
Index: code/trunk/src/libraries/core/Core.cc
===================================================================
--- code/trunk/src/libraries/core/Core.cc	(revision 11056)
+++ code/trunk/src/libraries/core/Core.cc	(revision 11071)
@@ -83,5 +83,5 @@
 {
     //! Static pointer to the singleton
-    Core* Core::singletonPtr_s  = 0;
+    Core* Core::singletonPtr_s  = nullptr;
 
     SetCommandLineArgument(settingsFile, "orxonox.ini").information("THE configuration file");
@@ -98,24 +98,24 @@
 
     Core::Core(const std::string& cmdLine)
-        : applicationPaths_(NULL)
-        , configurablePaths_(NULL)
-        , dynLibManager_(NULL)
-        , signalHandler_(NULL)
-        , configFileManager_(NULL)
-        , languageInstance_(NULL)
-        , loaderInstance_(NULL)
-        , ioConsole_(NULL)
-        , tclBind_(NULL)
-        , tclThreadManager_(NULL)
-        , rootScope_(NULL)
-        , graphicsManager_(NULL)
-        , inputManager_(NULL)
-        , guiManager_(NULL)
-        , graphicsScope_(NULL)
+        : applicationPaths_(nullptr)
+        , configurablePaths_(nullptr)
+        , dynLibManager_(nullptr)
+        , signalHandler_(nullptr)
+        , configFileManager_(nullptr)
+        , languageInstance_(nullptr)
+        , loaderInstance_(nullptr)
+        , ioConsole_(nullptr)
+        , tclBind_(nullptr)
+        , tclThreadManager_(nullptr)
+        , rootScope_(nullptr)
+        , graphicsManager_(nullptr)
+        , inputManager_(nullptr)
+        , guiManager_(nullptr)
+        , graphicsScope_(nullptr)
         , bGraphicsLoaded_(false)
-        , staticInitHandler_(NULL)
-        , pluginManager_(NULL)
-        , rootModule_(NULL)
-        , config_(NULL)
+        , staticInitHandler_(nullptr)
+        , pluginManager_(nullptr)
+        , rootModule_(nullptr)
+        , config_(nullptr)
         , destructionHelper_(this)
     {
@@ -179,5 +179,5 @@
 
         // initialize root context
-        Context::setRootContext(new Context(NULL));
+        Context::setRootContext(new Context(nullptr));
 
         // Do this soon after the ConfigFileManager has been created to open up the
@@ -282,7 +282,7 @@
 
         const std::vector<std::string>& modulePaths = ApplicationPaths::getInstance().getModulePaths();
-        for (std::vector<std::string>::const_iterator it = modulePaths.begin(); it != modulePaths.end(); ++it)
-        {
-            ModuleInstance* module = new ModuleInstance(*it);
+        for (const std::string& modulePath : modulePaths)
+        {
+            ModuleInstance* module = new ModuleInstance(modulePath);
             this->loadModule(module);
             this->modules_.push_back(module);
@@ -312,7 +312,6 @@
     void Core::unloadModules()
     {
-        for (std::list<ModuleInstance*>::iterator it = this->modules_.begin(); it != this->modules_.end(); ++it)
-        {
-            ModuleInstance* module = (*it);
+        for (ModuleInstance* module : this->modules_)
+        {
             this->unloadModule(module);
             delete module;
@@ -329,5 +328,5 @@
         module->deleteAllStaticallyInitializedInstances();
         this->dynLibManager_->unload(module->getDynLib());
-        module->setDynLib(NULL);
+        module->setDynLib(nullptr);
     }
 
@@ -464,6 +463,6 @@
     {
         // Update UpdateListeners before general ticking
-        for (ObjectList<UpdateListener>::iterator it = ObjectList<UpdateListener>::begin(); it != ObjectList<UpdateListener>::end(); ++it)
-            it->preUpdate(time);
+        for (UpdateListener* listener : ObjectList<UpdateListener>())
+            listener->preUpdate(time);
         if (this->bGraphicsLoaded_)
         {
@@ -474,5 +473,5 @@
         }
         // Process console events and status line
-        if (this->ioConsole_ != NULL)
+        if (this->ioConsole_ != nullptr)
             this->ioConsole_->preUpdate(time);
         // Process thread commands
@@ -483,6 +482,6 @@
     {
         // Update UpdateListeners just before rendering
-        for (ObjectList<UpdateListener>::iterator it = ObjectList<UpdateListener>::begin(); it != ObjectList<UpdateListener>::end(); ++it)
-            it->postUpdate(time);
+        for (UpdateListener* listener : ObjectList<UpdateListener>())
+            listener->postUpdate(time);
         if (this->bGraphicsLoaded_)
         {
Index: code/trunk/src/libraries/core/Core.h
===================================================================
--- code/trunk/src/libraries/core/Core.h	(revision 11056)
+++ code/trunk/src/libraries/core/Core.h	(revision 11071)
@@ -73,5 +73,5 @@
 
             /// Leave empty and use destroy() instead
-            ~Core() {}
+            ~Core() = default;
             /// Destructor that also executes when the object fails to construct
             void destroy();
@@ -92,5 +92,7 @@
 
         private:
-            Core(const Core&); //!< Don't use (undefined symbol)
+            // non-copyable:
+            Core(const Core&) = delete;
+            Core& operator=(const Core&) = delete;
 
             void setThreadAffinity(int limitToCPU);
Index: code/trunk/src/libraries/core/CoreConfig.cc
===================================================================
--- code/trunk/src/libraries/core/CoreConfig.cc	(revision 11056)
+++ code/trunk/src/libraries/core/CoreConfig.cc	(revision 11071)
@@ -35,4 +35,6 @@
 #include "core/Language.h"
 #include "core/ApplicationPaths.h"
+
+#include <random>
 
 namespace orxonox
@@ -106,7 +108,6 @@
     {
         // Inform listeners
-        ObjectList<DevModeListener>::iterator it = ObjectList<DevModeListener>::begin();
-        for (; it != ObjectList<DevModeListener>::end(); ++it)
-            it->devModeChanged(bDevMode_);
+        for (DevModeListener* listener : ObjectList<DevModeListener>())
+            listener->devModeChanged(bDevMode_);
     }
 
@@ -129,5 +130,8 @@
         if (!bInitialized && this->bInitRandomNumberGenerator_)
         {
-            srand(static_cast<unsigned int>(time(0)));
+            std::random_device rnddev;
+            rndseed(rnddev());
+            //Keep the old seeding around because people will probably still use the old functions
+            srand(rnddev());
             rand();
             bInitialized = true;
@@ -137,10 +141,10 @@
     void CoreConfig::updateLastLevelTimestamp()
     {
-        ModifyConfigValue(lastLevelTimestamp_, set, static_cast<long long>(time(NULL)));
+        ModifyConfigValue(lastLevelTimestamp_, set, static_cast<long long>(time(nullptr)));
     }
 
     void CoreConfig::updateOgreConfigTimestamp()
     {
-        ModifyConfigValue(ogreConfigTimestamp_, set, static_cast<long long>(time(NULL)));
+        ModifyConfigValue(ogreConfigTimestamp_, set, static_cast<long long>(time(nullptr)));
     }
 
Index: code/trunk/src/libraries/core/CoreConfig.h
===================================================================
--- code/trunk/src/libraries/core/CoreConfig.h	(revision 11056)
+++ code/trunk/src/libraries/core/CoreConfig.h	(revision 11071)
@@ -76,5 +76,5 @@
     public:
         DevModeListener();
-        virtual ~DevModeListener() {}
+        virtual ~DevModeListener() = default;
         virtual void devModeChanged(bool value) = 0;
     };
Index: code/trunk/src/libraries/core/CoreIncludes.h
===================================================================
--- code/trunk/src/libraries/core/CoreIncludes.h	(revision 11056)
+++ code/trunk/src/libraries/core/CoreIncludes.h	(revision 11071)
@@ -120,5 +120,5 @@
 */
 #define RegisterAbstractClass(ClassName) \
-    RegisterClassWithFactory(ClassName, static_cast<ClassFactory<ClassName>*>(NULL), false)
+    RegisterClassWithFactory(ClassName, static_cast<ClassFactory<ClassName>*>(nullptr), false)
 
 /**
@@ -221,5 +221,5 @@
         struct InheritsFromClass : public Identifier::InheritsFrom
         {
-            virtual Identifier* getParent() const { return Class(T); }
+            virtual Identifier* getParent() const override { return Class(T); }
         };
 
@@ -231,10 +231,10 @@
             ~StaticallyInitializedIdentifier() { identifier_->destroy(); }
 
-            virtual void load()
+            virtual void load() override
             {
                 IdentifierManager::getInstance().addIdentifier(this->identifier_);
             }
 
-            virtual void unload()
+            virtual void unload() override
             {
                 IdentifierManager::getInstance().removeIdentifier(this->identifier_);
Index: code/trunk/src/libraries/core/CorePrecompiledHeaders.h
===================================================================
--- code/trunk/src/libraries/core/CorePrecompiledHeaders.h	(revision 11056)
+++ code/trunk/src/libraries/core/CorePrecompiledHeaders.h	(revision 11071)
@@ -50,4 +50,5 @@
 #include <sstream>  // 53
 #include <set>      // 50
+#include <memory>
 
 #include "util/Output.h" // 48
@@ -66,5 +67,4 @@
 #include <OgreColourValue.h> // 36
 #include <boost/preprocessor/cat.hpp> // 27
-#include <boost/shared_ptr.hpp> // 21
 
 #ifdef ORXONOX_COMPILER_MSVC
@@ -76,5 +76,4 @@
 #include "util/SubString.h"  // 14
 
-#include <boost/scoped_ptr.hpp> // 13
 #include <stack> // 12
 
